<?xml version="1.0" encoding="UTF-8"?>
<genmodel:GenModel xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore"
    xmlns:genmodel="http://www.eclipse.org/emf/2002/GenModel" modelDirectory="/org.eclipse.lsat.common.graph.directed/src-gen"
    editDirectory="" editorDirectory="" modelPluginID="org.eclipse.lsat.common.graph.directed"
    modelName="Directed_graph" rootExtendsClass="org.eclipse.emf.ecore.impl.MinimalEObjectImpl$Container"
    testsDirectory="" importerID="org.eclipse.emf.importer.ecore" complianceLevel="7.0"
    copyrightFields="false" operationReflection="true" importOrganizing="true">
  <foreignModel>directed_graph.ecore</foreignModel>
  <genPackages prefix="DirectedGraph" basePackage="org.eclipse.lsat.common.graph"
      disposableProviderFactory="true" ecorePackage="directed_graph.ecore#/">
    <genClasses ecoreClass="directed_graph.ecore#//DirectedGraph">
      <genTypeParameters ecoreTypeParameter="directed_graph.ecore#//DirectedGraph/N"/>
      <genTypeParameters ecoreTypeParameter="directed_graph.ecore#//DirectedGraph/E"/>
      <genFeatures createChild="false" ecoreFeature="ecore:EAttribute directed_graph.ecore#//DirectedGraph/name"/>
      <genFeatures children="true" createChild="true" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//DirectedGraph/subGraphs"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//DirectedGraph/parentGraph"/>
      <genFeatures property="None" children="true" createChild="true" ecoreFeature="ecore:EReference directed_graph.ecore#//DirectedGraph/edges"/>
      <genFeatures property="None" children="true" createChild="true" ecoreFeature="ecore:EReference directed_graph.ecore#//DirectedGraph/nodes"/>
      <genFeatures children="true" createChild="true" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//DirectedGraph/aspects"/>
      <genOperations ecoreOperation="directed_graph.ecore#//DirectedGraph/allNodesInTopologicalOrder"
          body="if (null != getParentGraph()) return getParentGraph().allNodesInTopologicalOrder();&#xD;&#xA;return org.eclipse.lsat.common.graph.directed.util.DirectedGraphQueries.topologicalOrdering(&#xD;&#xA;&#x9;org.eclipse.lsat.common.graph.directed.util.DirectedGraphQueries.allSubNodes(this));"/>
    </genClasses>
    <genClasses ecoreClass="directed_graph.ecore#//Node">
      <genFeatures createChild="false" ecoreFeature="ecore:EAttribute directed_graph.ecore#//Node/name"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Node/outgoingEdges"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Node/incomingEdges"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Node/graph"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Node/aspects"/>
    </genClasses>
    <genClasses ecoreClass="directed_graph.ecore#//Edge">
      <genFeatures createChild="false" ecoreFeature="ecore:EAttribute directed_graph.ecore#//Edge/name"
          get="StringBuffer name = new StringBuffer();&#xD;&#xA;if (null == sourceNode) {&#xD;&#xA;&#x9;name.append(&quot;null&quot;);&#xD;&#xA;} else if (null == sourceNode.getName()) {&#xD;&#xA;&#x9;name.append(&quot;&lt;&lt;no_name>>&quot;);&#xD;&#xA;} else {&#xD;&#xA;&#x9;name.append(sourceNode.getName());&#xD;&#xA;}&#xD;&#xA;name.append(&quot; -> &quot;);&#xD;&#xA;if (null == targetNode) {&#xD;&#xA;&#x9;name.append(&quot;null&quot;);&#xD;&#xA;} else if (null == targetNode.getName()) {&#xD;&#xA;&#x9;name.append(&quot;&lt;&lt;no_name>>&quot;);&#xD;&#xA;} else {&#xD;&#xA;&#x9;name.append(targetNode.getName());&#xD;&#xA;}&#xD;&#xA;return name.toString();"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Edge/sourceNode"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Edge/targetNode"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Edge/graph"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Edge/aspects"/>
    </genClasses>
    <genClasses ecoreClass="directed_graph.ecore#//Aspect">
      <genTypeParameters ecoreTypeParameter="directed_graph.ecore#//Aspect/N"/>
      <genTypeParameters ecoreTypeParameter="directed_graph.ecore#//Aspect/E"/>
      <genFeatures createChild="false" ecoreFeature="ecore:EAttribute directed_graph.ecore#//Aspect/name"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Aspect/edges"/>
      <genFeatures notify="false" createChild="false" propertySortChoices="true" ecoreFeature="ecore:EReference directed_graph.ecore#//Aspect/nodes"/>
      <genFeatures property="None" notify="false" createChild="false" ecoreFeature="ecore:EReference directed_graph.ecore#//Aspect/graph"/>
    </genClasses>
  </genPackages>
</genmodel:GenModel>
